
header "SysUtil" /{

#define LDDK_CPY_FROMFS %<driver.name>_GetFromFS
#define LDDK_CPY_TOFS   %<driver.name>_PutToFS


}/
/*----------------------------------------------------------------------*/
file "SysUtil" /{

void *%<driver.name>_GetFromFS(void *source, unsigned long len)
{
  void *buf;
  DBGin("%<driver.name>_GetFromFS");
   if( verify_area(VERIFY_READ,source,len) ){
	DBGprint(DBG_DATA,("verify Error"));
	DBGout();return NULL;
   }
   if(( buf = (void *) kmalloc(len+1,GFP_KERNEL) ) == NULL ){
	DBGprint(DBG_DATA,("kmalloc Error"));
	DBGout();return NULL;
   }
   memcpy_fromfs( buf, source, len);
  DBGout();  return buf;
}


void %<driver.name>_PutToFS(void *target,void *source, unsigned long len)
{
  DBGin("lddk_PutToFS");
   if( verify_area(VERIFY_WRITE,target,len) ){
	DBGprint(DBG_DATA,("verify Error"));
	DBGout();return NULL;
   }
   memcpy_tofs( target, source, len);
  DBGout();
}

}/
