
header "ltimer" /{

#define LDDK_START_TIMER %<driver.name>_StartTimer
#define LDDK_STOP_TIMER  %<driver.name>_StopTimer


extern volatile int %<driver.name>_Timeout;

}/


file "ltimer" /{

int %<driver.name>_Timeout = 0;
struct timer_list %<driver.name>_Timer;


void %<driver.name>_TimerInterrupt(unsigned long unused)
{
#if DEBUG
	if (dbgMask & DBG_INTR)
		printk("TIMER INTERRUPT!\n");
#endif
        %<driver.name>_Timeout = 1;

}

void %<driver.name>_StartTimer(unsigned long v)
{
	DBGin("%<driver.name>_StartTimer");
	%<driver.name>_Timeout = 0;
	%<driver.name>_Timer.expires = jiffies + v;
	%<driver.name>_Timer.function = %<driver.name>_TimerInterrupt;
	add_timer( &%<driver.name>_Timer);

	DBGout();
}

void %<driver.name>_StopTimer()
{
        DBGin("%<driver.name>_StopTimer");
          del_timer( &%<driver.name>_Timer );

	DBGout();
}




}/