/* 
 * This is a very simple example for a dummy driver module that does
 * nothing else than giving out stupid messages to the syslog file
 *
 */

/@ 
This stupid module consists of one global driver module 
you can specify a default major number here that can be overrided
by loading the driver with
/sbin/insmod Stupid.o Stupid_major=<my_major>
@/
module "Proc" : /* this directive sets the global module name */

/*macro "test" /{ blah }/ */

driver "main" [ major=34 ] {


        header "proc" /{
	
	/* %<test? alternate1 : alternate2 > */
	
	#include <linux/proc_fs.h>

        #ifdef CONFIG_PROC_FS

        extern int test_get_info(char *, char **, off_t , 
	                          int , int );
        static struct proc_dir_entry    test_proc_entry = {
	            0, %<len(driver.name)>, "%<driver.name>", S_IFREG | S_IRUGO, 1, 0, 0, 0, 0, test_get_info
		    };
        #endif
		   
	}/
	
	file "proc" /{	   
		   
		   
	int test_get_info(char *buf, char **start, off_t fpos, 
	                  int length, int dummy){
			  
	char *          p;
	
	p = buf;
	
	p += sprintf(p,"Proc entry from %<driver.name>\n");
	
	return p - buf;
		    
	} 
        }/


         /*
         * The main module of a driver uses the core method whenever the module
         * is loaded or unloaded to the kernel with insmod
         * the init method will be executed on load and the cleanup method on
         * unload time
         */
	core {  
		init /{ 
		/* %<driver.name| another test> */
			printk("This is a real stupid message\n");
		#ifdef CONFIG_PROC_FS
		        proc_register_dynamic(&proc_root, &test_proc_entry);
		#endif
		}/

		cleanup /{
			printk("Have a nice day! \n");
			
		#ifdef CONFIG_PROC_FS
		        printk("Unregister inode %d",test_proc_entry.low_ino);
                        proc_unregister(&proc_root,
                                        test_proc_entry.low_ino );
                #endif
		
		}/
	}
        /*
         * This method will be called whenever the driver is opened
         */
	open /{
                /* %<driver.name> */
		printk("Stupid module has been opened\n");
	}/

        /*
         * This method will be called whenever the driver is closed
         */
	close /{
		printk("Stupid module has been closed\n");
	}/

        /*
         * This method will be called on read
         */
	read 
        /@
	  Normally read reads a buffer into a userspace buffer
          here it is a stupid function that gives out a stupid message
        @/ 
        /{
		printk("Stupid module read() called\n");
	}/
        

        /*
         * This method will be called by calling the ioctl() function
         *
         * within the ioctl method different submethods can be specified
         * the 'func' method for example expands automatically to the
         * desired library function with the same name and call convention
         *
         */
	ioctl {
             /* from the library this method is simply called with 
              * SetMode( flags );
              */

	     func SetMode (int flags) 
             /@
               Sets the mode flag register
               according to the following table

                 0xa  sets a
                 0xb  sets b

             @/

	     /{
		printk("Stupid Mode flags is %d",flags);
	     }/

        }
}

