file "Rdestroy" /{

/*
 * RCS_destroy() destroy hashtable and free all allocated memory
 *
 */

int RCS_destroy() {
  int i;
  RCS_entry *np,*op;
  DBGin("RCS_destroy");
  for(i=0;i<RCS_HASHSIZE;i++) {
    for( np = RCS_hashtab[i]; np != NULL; ) {
      if( np->type == RCS_STRING && np->uval.sval != NULL )
	kfree(np->uval.sval);
      DBGprint(DBG_DATA,("destroy: %s\n",np->name));
      op = np->next; /* save pointer */
      kfree( np );
      np = op;
    }
  }
  DBGout();
}


}/