.\" Copyright (c) 1996 Claus Schrter (clausi@chemie.fu-berlin.de)
.\" This program is distributed according to the Gnu General Public License.
.\" See the file COPYING in the kernel source directory /linux
.\" This file has been generated with ddl2c
.\"
.TH "%<driver.name>" 4 "Linux driver development Kit" "%<driver.name> module" "LDDK"
.SH NAME
%<driver.name> 
.SH DESCRIPTION
.nf
%<doc.module-desc>
.fi
.SH Device inode
The device inode is typically created by typing

.nf
	mknod /dev/%<driver.name> c <major> <minor>
.fi

If another major is needed it can be specified by the
%<driver.name>_major option to insmod

.nf
	insmod %<driver.name>.o %<driver.name>_major=new_major
.fi
.SH Debugging Information:
All driver generated with LDDK have debugging information
compiled into the code that can be configured with the dbgMask
option to insmod. The bits of dbgMask specifies the debugging verbosity:

.nf
	Bit-0 Flag for setting all options=on
	Bit-1 function entrys
	Bit-2 function exits
	Bit-3 branches
	Bit-4 data given to functions
	Bit-5 interrupts
	Bit-6 register info
	Bit-7 reserved
.fi
For example:

.nf
	insmod %<driver.name>.o dbgMask=0x06
.fi

logs all function entrys and exits to the kernel log daemon.
%<doc.add-man>
.SH SEE ALSO
.BR   insmod "(1), " rmmod "(1), " mknod "(1), " klogd "(1)"
