#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/sched.h>
#include <linux/tty.h>
#include <linux/signal.h>
#include <linux/errno.h>
#include <linux/major.h>
#include <linux/module.h>
#include <linux/version.h>
#include <linux/malloc.h>
#include <linux/mm.h>
#include <linux/timer.h>
#include <linux/wrapper.h>


#include <asm/io.h>
#include <asm/segment.h>
#include <asm/system.h>
#include <asm/irq.h>
#include <asm/dma.h>

%<driver.include-debug>
%<driver.include-proto>
%<driver.include-ioctl>
%<driver.include-types>


%<driver.procinfo-defs>
%<driver.sysctl-defs>


#ifndef %<driver.name>_MAJOR
#define %<driver.name>_MAJOR %<driver.major>
#endif

extern int %<driver.name>_errno;

%<driver.custom-defines>
%<driver.custom-headers>

%<driver.add-headers>

#ifdef USE_LDDK_RETURN
#define LDDK_RETURN(arg) DBGout();return(arg)
#else
#define LDDK_RETURN(arg) return(arg)
#endif

