#include "common.h"
#include "hash.h"

void dump_doc(int type,char *topic,char *syn){
extern int doc_stat;
extern DynString *doc_buffer;
char *module_name;
char *driver_name;

char buf[512];
if(doc_stat){
         driver_name = hash_get("driver.name");

	switch(type) {
	case 1: /* driver functiond */
        case 2: /* C-library functions */
	case 3: /* programming manual functions */
         module_name = hash_get("driver.modname");
         if ( type != 1 ) {
  	   sprintf(buf,"#include <%s_lib.h>",driver_name);
	   hash_install("doc.include",buf);
         }
         sprintf(buf,"%s_%s",( type == 3 ? module_name : driver_name ),topic);

	 hash_install("doc.topic",buf);

         sprintf(buf,(type==3?"(int fd, %s)":"(%s)"),syn);

	 hash_install("doc.topic-param",buf);
         hash_install("doc.description",DSget(doc_buffer));
         if( type == 1 ) {
	   sprintf(buf,"%s_%s.3",driver_name,topic);
	   dump_file("doc","man.2a",buf);
	   sprintf(buf,"%s_%s.html",driver_name,topic);
	   dump_file("doc","html.2a",buf);
	 } else
         if( type == 3 ) {
           sprintf(buf,"%s_%s.3",module_name,topic);
 	   dump_file("doc","man.3",buf);
	   sprintf(buf,"%s_%s.html",module_name,topic);
	   dump_file("doc","html.3",buf);
	 } else { /* library functions */
	   sprintf(buf,"%s_%s.3",driver_name,topic);
	   dump_file("doc","man.2",buf);
	   sprintf(buf,"%s_%s.html",driver_name,topic);
	   dump_file("doc","html.2",buf);
	 }
	 break;
	case 4: /* device section (module description) */
	 hash_install("doc.module-desc",DSget(doc_buffer));
         sprintf(buf,"%s.4",driver_name);
	 dump_file("doc","man.4",buf);
	 sprintf(buf,"%s.html",driver_name);
	 dump_file("doc","html.4",buf);
	break; 
        }
}
doc_stat = 0;

}
