

#include <stdio.h>
#include <stdlib.h>

#define MAX_PARAMS 20
#define MAX_FUNCS  50
#define MAX_DEFS   50

#define MAX_HASHSIZE 500
/*********************/

#define CHAR_TYPE 1
#define INT_TYPE  2
#define LONG_TYPE 3
#define OPAQUE_TYPE 4
#define STRING_TYPE 5
#define ISTRING_TYPE 6





struct hlist_entry {
  char *ident;
  char *val;
  struct hlist_entry *next;
};

extern char *hash_get(char *);
extern struct hlist_entry *hash_lookup(char *);
extern struct hlist_entry *hash_install(char *,char *);

extern char *strsave(char *);
extern char *uppercase(char *);
