macro "driver.add-headers" /{
#include <rmgr_P.h>
%<driver.add-headers>
}/

macro "driver.rmgr_init" /{ 

{
       RCS_entry v;
       RCS_entry *np;
       np=RCS_lookup("%<driver.name>::major");
       if( np == NULL ){
                printk("%<driver.name>: ressource 'major' not found\n");
       }        
       else 
       {
          %<driver.name>_major = np->uval.ival;
          printk("%<driver.name>: Major = %d\n",%<driver.name>_major);
       }
       v.type = RCS_IPTR;
       v.uval.iptr = &dbgMask;
       np = RCS_install("%<driver.name>::debug",&v);
}
%<driver.rmgr_init>

}/

macro "doc.add-html" /{
%<doc.add-html>
<hr><p>
<h3>Registry Options:</h3><p>
This module has two global options in the registry (rmgr) database:
<br><p>
<b>%<driver.name>::major</b> type=int <br>  
                                <blockquote>
                                 The device driver major number
			        (can only be set in /etc/kres.conf before
                                 the module is loaded) </blockquote>
<br>
<b>%<driver.name>::debug</b> type=int <br> <blockquote>  
                                Dynamic debug level </blockquote>

}/

macro "doc.add-man" /{
%<doc.add-man>
.SH Registry Options: 
This module has two global options in the registry (rmgr) database:

.nf
     %<driver.name>::major   The device driver major number
			        (can only be set in /etc/kres.conf before
                                 the module is loaded)
     %<driver.name>::debug   Dynamic debug level
.fi

}/




