.\" Copyright (c) 1996 Claus Schrter (clausi@chemie.fu-berlin.de)
.\" This program is distributed according to the Gnu General Public License.
.\" See the file COPYING in the kernel source directory /linux
.\" This file has been generated with ddl2c
.\"
.TH "ddl2c" 3 "Linux driver development Kit" "DDL to C compiler" "LDDK tools"
.SH NAME
ddl2c \- The DDL to C compiler
.sp
.B ddl2c [options] files
.fi
.SH DESCRIPTION
.sp
ddl2c takes a Driver Description file written in DDL and generates a driver sourcetree
in the local directory. 
.fi
.SH OPTIONS
.nf
.B --templates, -T 
	set template path

.B --includes,  -I 
	set include path

.B --noline,    -l
	generate without #line directives

.B --make,      -m     
	execute make after generating files

.B --help,      -?     
	display help screen
.fi
.SH EXAMPLES
.nf
	ddl2c -m Simple.ddl
	cd Simple ; make load

.fi
will generate the sourcetree according to the module name set in Simple.ddl
and will exececute a make in this directory. (You'll find this example
in the ./examples/basics directory of LDDK).
.SH SEE ALSO
related docs
