/@ 
   This module shows how the 'procinfo' method can be used to export kernel data to
   /proc/<driver.name> 
@/

module "Procinfo" : 
driver "Pmain" [ major=34 ] {

	core {  
		init /{ 
			printk("This is a real stupid message\n");
		}/

		cleanup /{
			printk("Have a nice day! \n");
		}/
	}

        procinfo /{
                char *p;
	
	        p = buf; /* buf is defined implicitely */
		p += sprintf(p,"Proc entry from %<driver.name>\n");
		retval = p - buf;
        }/

	open /{
		printk("Stupid module has been opened\n");
	}/

	close /{
		printk("Stupid module has been closed\n");
	}/

}

