 /*
  * Generated with LDDK Version 0.6-beta 
  *     (c) 1996,1997 Claus Schroeter (clausi@chemie.fu-berlin.de) all rights reserved,
  *         lddk is availiable from the Linux Lab Project
  *             http://www.llp.fu-berlin.de/
  *         or by anonymus FTP
  *             ftp://ftp.llp.fu-berlin.de/pub/linux/LINUX-LAB/LDDK
  *
  */
#include <Signal_P.h>
#include <linux/version.h>

char kernel_version[] = UTS_RELEASE;

#define LDDK_USE_REGISTER 1


#ifdef LDDK_USE_REGISTER
    int Signal_major = Signal_MAJOR; 
  
struct file_operations Signal_fops = { 
NULL, 
NULL, 
NULL, 
NULL, 
NULL, 
NULL, 
NULL, 
Signal_open, 
Signal_close, 
};

#endif

#ifdef __cplusplus
extern "C" {
#endif

int init_module(void)
{
  DBGin("init_module");
  {
  	
  }
#ifdef LDDK_USE_REGISTER
      if( register_chrdev(Signal_major,"Signal",&Signal_fops) ){
      printk("can't get Major %d\n",Signal_major);
      return(-EIO);
    }
  

#endif
  {
    #line 52 "Signal.ddl" 
			printk("init called\n");			
		
  }
#if LDDK_USE_PROCINFO
  register_procinfo();
#endif
#if LDDK_USE_SYSCTL
  register_systables();
#endif
  DBGout();
  return 0;
}

void cleanup_module(void)
{
  DBGin("cleanup_module");
  if (MOD_IN_USE) {
    printk("Signal : device busy, remove delayed\n");
  }

  {
    #line 56 "Signal.ddl"
			printk("cleanup called\n");
		
  }
#ifdef LDDK_USE_REGISTER
      if( unregister_chrdev(Signal_major,"Signal") != 0 ){
      printk("can't unregister Signal, device busy \n");
    } else {
      printk("Signal successfully removed\n");
    }
  

#endif
#if LDDK_USE_PROCINFO
  unregister_procinfo();
#endif
#if LDDK_USE_SYSCTL
  unregister_systables();
#endif
  DBGout();
}


#ifdef __cplusplus
}
#endif

