
file "Rinit" /{

RCS_entry *RCS_hashtab[RCS_HASHSIZE];


void RCS_ChangeCB(int event,RCS_entry *np){

	DBGin("RCS_ChangeCB");
	DBGprint(DBG_DATA,("event=%d",event));
	switch (event) {
		case RCS_CHANGE_EVENT:
		 printk("'%s' changed \n",np->name);
		break;
        }
	DBGout();


}
/*
 * RCS_init() initialize the hash-table
 *
 */

int RCS_init()
{
  int i;
  RCS_entry v;
  RCS_entry *np;
  extern int umask;

  DBGin("RCS_init");

  for (i=0;i<RCS_HASHSIZE;i++)
    RCS_hashtab[i] = (RCS_entry *) NULL;

  v.type = RCS_STRING;
  v.uval.sval = RMGR_VERSION;
  np = RCS_install("rmgr::version",&v);  
  np->mflags = O_RD | G_RD | A_RD | PERM_STICKY;

  v.type = RCS_IPTR;
  v.uval.iptr = &dbgMask;
  np = RCS_install("rmgr::debug",&v);
  np->callback = RCS_ChangeCB;
  np->mflags = O_RD | O_WR | PERM_STICKY;

  v.type = RCS_IPTR;
  v.uval.iptr = &umask;
  np = RCS_install("rmgr::umask",&v);
  np->callback = RCS_ChangeCB;
  np->mflags = O_RD | O_WR | PERM_STICKY;



  DBGout();
}


}/

