#
#   
#   This Makefile has been generated with LDDK Version %<version>
#   (c) 1996 by Claus Schroeter (clausi@chemie.fu-berlin.de)
#
#   To get language support you need the swig generator to be installed
#   see http://www.cs.utah.edu/~beazley/SWIG/ for details.
#
#   Creation Date: %<date>

SWIG=swig
INCLUDES = -I. -I../include
DEFS = %<lang.make-defs>
LIBS = -ldl
CFLAGS = -fpic -O6 $(INCLUDES) $(DEFS)

DRIVER=%<driver.name>
MODULE=%<driver.modname>

OBJS= $(MODULE)_file.o
SRCS= $(MODULE)_file.c

########################################

all: $(DRIVER)_tcl.so inode


### Rules for Tcl/Tk generation

$(DRIVER)_tclsh: $(DRIVER)_twrap.o $(OBJS)
	$(CC) $(DRIVER)_twrap.o -L../lib -l%<driver.name> -ltcl $(LIBS) -lm -o $(DRIVER)_tclsh 

$(DRIVER)_tcl.so: $(DRIVER)_twrap.o $(OBJS)
	$(CC) -shared  $(OBJS) $(DRIVER)_twrap.o  -o $(DRIVER)_twrap.so  -L../lib -l%<driver.name>

$(DRIVER)_twrap.o: $(DRIVER)_twrap.c

$(DRIVER)_twrap.c: $(DRIVER).i
	$(SWIG) -tcl -o $(DRIVER)_twrap.c $(DRIVER).i


inode:
	-mknod ./test c %<driver.major> 0
	-chmod a+x ./test.tcl

clean: 
	-rm *.o *_twrap.* *.doc *.so *_tclsh


